(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('ng-inject-control', ['exports', '@angular/core', '@angular/forms'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ng-inject-control'] = {}, global.ng.core, global.ng.forms));
}(this, (function (exports, i0, i1) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);

    var NG_INJECTABLE_CONTROL = new i0.InjectionToken('ng-injectable-control');
    function injectableControlProvider(type) {
        return {
            provide: NG_INJECTABLE_CONTROL,
            useExisting: i0.forwardRef(function () { return type; }),
        };
    }

    /**
     * Work around for ExpressionChangeAfterCheckedError from
     * https://stackoverflow.com/questions/45661010/dynamic-nested-reactive-form-expressionchangedafterithasbeencheckederror
     */
    var resolvedPromise = (function () { return Promise.resolve(null); })();
    var InjectControlDirective = /** @class */ (function () {
        function InjectControlDirective(controlContainer, host) {
            this.controlContainer = controlContainer;
            this.host = host;
        }
        Object.defineProperty(InjectControlDirective.prototype, "disabled", {
            set: function (isDisabled) {
                var control = this.host.control;
                if (isDisabled && control.enabled) {
                    control.disable();
                }
                else if (!isDisabled && control.disabled) {
                    control.enable();
                }
            },
            enumerable: false,
            configurable: true
        });
        /**
         * TODO: Use on changes instead and support a case where the input can be
         * changed, similar to how FormControlName and FormControlDirective work.
         */
        InjectControlDirective.prototype.ngOnInit = function () {
            var _this = this;
            var parent = this.controlContainer.control;
            if (parent instanceof i1.FormGroup) {
                var control_1 = parent.get(this.injectControl);
                if (!control_1) {
                    throw new Error("No control " + this.injectControl + " in control container");
                }
                this.originalControl = control_1;
                resolvedPromise.then(function () {
                    if (control_1.value) {
                        _this.host.control.patchValue(control_1.value);
                    }
                    if (control_1.validator) {
                        _this.host.control.setValidators(control_1.validator);
                        _this.host.control.updateValueAndValidity({
                            onlySelf: true,
                            emitEvent: false,
                        });
                    }
                    if (control_1.asyncValidator) {
                        _this.host.control.setAsyncValidators(control_1.asyncValidator);
                        _this.host.control.updateValueAndValidity({
                            onlySelf: true,
                            emitEvent: false,
                        });
                    }
                    parent.setControl(_this.injectControl, _this.host.control);
                    parent.updateValueAndValidity({ emitEvent: false });
                });
            }
            else {
                throw new Error("Unsupported control container type " + (parent === null || parent === void 0 ? void 0 : parent.constructor.name));
            }
        };
        InjectControlDirective.prototype.ngOnDestroy = function () {
            var _this = this;
            var parent = this.controlContainer.control;
            if (parent instanceof i1.FormGroup) {
                resolvedPromise.then(function () {
                    if (_this.originalControl) {
                        parent.setControl(_this.injectControl, _this.originalControl);
                        parent.updateValueAndValidity({ emitEvent: false });
                    }
                });
            }
        };
        return InjectControlDirective;
    }());
    InjectControlDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.1.0", ngImport: i0__namespace, type: InjectControlDirective, deps: [{ token: i1__namespace.ControlContainer }, { token: NG_INJECTABLE_CONTROL, host: true }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    InjectControlDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.1.0", type: InjectControlDirective, selector: "[injectControl]", inputs: { injectControl: "injectControl", disabled: "disabled" }, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.1.0", ngImport: i0__namespace, type: InjectControlDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[injectControl]',
                    }]
            }], ctorParameters: function () {
            return [{ type: i1__namespace.ControlContainer }, { type: undefined, decorators: [{
                            type: i0.Host
                        }, {
                            type: i0.Inject,
                            args: [NG_INJECTABLE_CONTROL]
                        }] }];
        }, propDecorators: { injectControl: [{
                    type: i0.Input
                }], disabled: [{
                    type: i0.Input
                }] } });

    var InjectControlModule = /** @class */ (function () {
        function InjectControlModule() {
        }
        return InjectControlModule;
    }());
    InjectControlModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.1.0", ngImport: i0__namespace, type: InjectControlModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    InjectControlModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.1.0", ngImport: i0__namespace, type: InjectControlModule, declarations: [InjectControlDirective], exports: [InjectControlDirective] });
    InjectControlModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.1.0", ngImport: i0__namespace, type: InjectControlModule });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.1.0", ngImport: i0__namespace, type: InjectControlModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [InjectControlDirective],
                        exports: [InjectControlDirective],
                    }]
            }] });

    /**
     * Generated bundle index. Do not edit.
     */

    exports.InjectControlDirective = InjectControlDirective;
    exports.InjectControlModule = InjectControlModule;
    exports.NG_INJECTABLE_CONTROL = NG_INJECTABLE_CONTROL;
    exports.injectableControlProvider = injectableControlProvider;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-inject-control.umd.js.map
